unit UTPlates;

interface

uses
  ShellAPI, Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Printers, ComCtrls, Clipbrd, Menus,
  UMisc, Grids, ExtCtrls;

Const
	PGMTITLE = 'TPlator';
	PGMNAME = 'TPlator - ';
	PGMCOPYRIGHT = 'Copyright  2001 rwbLinn';
  //files
	PGMINIFILE = 'tplator.ini';
	PGMLNGFILE = 'tplator.lng';

type
  TCustomEnumWindowsProc = Procedure(WinHandle : HWND);

  TfrmTemplates = class(TForm)
    pcTPlator: TPageControl;
    tsTemplates: TTabSheet;
    tsOptions: TTabSheet;
    lblDevType: TLabel;
    lblTemplateType: TLabel;
    bbOK: TBitBtn;
    mmTemplate: TMemo;
    bbTemplateToClipboard: TBitBtn;
    bbTemplateEdit: TBitBtn;
    bbIniEdit: TBitBtn;
    edAuthorName: TEdit;
    edAuthorEMail: TEdit;
    lblAuthorName: TLabel;
    lblAuthorEMail: TLabel;
    bbSaveOptions: TBitBtn;
    ReplaceDialog1: TReplaceDialog;
    FindDialog1: TFindDialog;
    tsEditor: TTabSheet;
    Memo1: TMemo;
    bbMemoSave: TBitBtn;
    bbMemoSaveAs: TBitBtn;
    bbMemoPrint: TBitBtn;
    bbMemoPrintSetup: TBitBtn;
    cbMemoFModified: TCheckBox;
    MemoOpenDialog1: TOpenDialog;
    MemoSaveDialog1: TSaveDialog;
    MemoPrinterSetupDialog1: TPrinterSetupDialog;
    MemoPrintDialog1: TPrintDialog;
    edMemoFind: TEdit;
    lblMemoFind: TLabel;
    lblMemoReplace: TLabel;
    bbMemoFind: TBitBtn;
    bbMemoReplace: TBitBtn;
    lblMemoFile: TLabel;
    edMemoReplace: TEdit;
    MemoReplaceDialog: TReplaceDialog;
    MemoFindDialog: TFindDialog;
    bbMemoOpen: TBitBtn;
    bbMemoNew: TBitBtn;
    bbHelp: TBitBtn;
    bbIniReload: TBitBtn;
    lblIniFile: TLabel;
    lblCurPos: TLabel;
    pmEditor: TPopupMenu;
    EditorPopUpInsertDateandTime: TMenuItem;
    EditorPopUpInsertAuthorinfo: TMenuItem;
    N1: TMenuItem;
    EditorPopUpClear: TMenuItem;
    EditorPopUpSelectAll: TMenuItem;
    N2: TMenuItem;
    EditorPopUpCopyClipboard: TMenuItem;
    EditorPopUpCutClipboard: TMenuItem;
    EditorPopUpPasteClipboard: TMenuItem;
    N3: TMenuItem;
    EditorPopUpSendText: TMenuItem;
    bbTemplateToActiveWindow: TBitBtn;
    cbWindowsList: TComboBox;
    lblWindowsList: TLabel;
    lblTemplateCopy: TLabel;
    bbRefreshWindowsList: TBitBtn;
    sgTemplateTypes: TStringGrid;
    lblTemplateInfo: TLabel;
    edAuthorWebSite: TEdit;
    lblAuthorWebSite: TLabel;
    lblAuthor: TLabel;
    edTemplateDir: TEdit;
    lblTemplateDir: TLabel;
    pmTemplates: TPopupMenu;
    TemplatesPopUpDevTypes: TMenuItem;
    TemplatesPopUpTemplates: TMenuItem;
    N4: TMenuItem;
    lbDevTypes: TListBox;
    edDevType: TEdit;
    bbAddDT: TBitBtn;
    bbUpdateDT: TBitBtn;
    bbDeleteDT: TBitBtn;
    bbAddTT: TBitBtn;
    bbUpdateTT: TBitBtn;
    bbDeleteTT: TBitBtn;
    sbTemplates: TStatusBar;
    edDevTypeComment: TEdit;
    lblDevTypeComment: TLabel;
    cbReplaceAuthorInfo: TCheckBox;
    bbCopyDT: TBitBtn;
    cbDevTypeStandard: TCheckBox;
    imAbout: TImage;
    TemplatesPopUpAddDT: TMenuItem;
    TemplatesPopUpUpdateDT: TMenuItem;
    TemplatesPopUpCopyDT: TMenuItem;
    TemplatesPopUpDeleteDT: TMenuItem;
    TemplatesPopUpAddTT: TMenuItem;
    TemplatesPopUpUpdateTT: TMenuItem;
    TemplatesPopUpDeleteTT: TMenuItem;
    edLanguageFile: TEdit;
    lblLanguageFile: TLabel;
    lblVarious: TLabel;
		//procedure CreateTemplate(sFilename: String);
    //stringgrid

		procedure UpdateIni;
		procedure UpdateIniDevTypeSection(sDevType : String);
		procedure SetStatusBar(Sender: TObject);
		procedure SetStringGrid(Sender: TObject);
		procedure SetDevTypes(Sender: TObject);
		procedure SetTemplateTypes(Sender: TObject);
		function FindDevType(sStr : String) : Integer;
		function FindTemplateType(sStr : String) : Boolean;
		function GetDevTypeIndex(sStr : String) : Integer;
    procedure ReadIni(Sender: TObject);
    procedure bbOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bbIniEditClick(Sender: TObject);
    procedure bbTemplateToClipboardClick(Sender: TObject);
    procedure bbTemplateEditClick(Sender: TObject);
    procedure mmTemplateChange(Sender: TObject);
    procedure bbSaveOptionsClick(Sender: TObject);
		procedure ReplaceDialog1Replace(Sender: TObject; sFindText : String; sReplaceText : String);
    procedure sgTemplateTypesClick(Sender: TObject);
    procedure sgTemplateTypesKeyPress(Sender: TObject; var Key: Char);

		function MemoOpen(const AFilename: string) : Boolean;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure bbMemoSaveClick(Sender: TObject);
    procedure bbMemoSaveAsClick(Sender: TObject);
		procedure bbMemoPrintClick(Sender: TObject);
    procedure bbMemoPrintSetupClick(Sender: TObject);
    procedure bbMemoSelectAllClick(Sender: TObject);
    procedure bbMemoPasteFromClipboardClick(Sender: TObject);
    procedure bbMemoCutToClipboardClick(Sender: TObject);
    procedure bbMemoCopyToClipboardClick(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
		procedure MemoFindDialogFind(Sender: TObject; sFindText : String);
		procedure MemoReplaceDialogReplace(Sender: TObject; sFindText : String; sReplaceText : String);
    procedure bbMemoFindClick(Sender: TObject);
    procedure bbMemoReplaceClick(Sender: TObject);
    procedure pcTPlatorChange(Sender: TObject);
    procedure bbClearMemoClick(Sender: TObject);
    procedure bbMemoOpenClick(Sender: TObject);
    procedure bbMemoNewClick(Sender: TObject);
    procedure bbHelpClick(Sender: TObject);
    procedure bbIniReloadClick(Sender: TObject);
    procedure bbInsertDTClick(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditorPopUpInsertDateandTimeClick(Sender: TObject);
    procedure EditorPopUpInsertAuthorinfoClick(Sender: TObject);
    procedure Memo1Enter(Sender: TObject);
    procedure pmEditorPopup(Sender: TObject);
    procedure EditorPopUpCopyClipboardClick(Sender: TObject);
    procedure EditorPopUpCutClipboardClick(Sender: TObject);
    procedure EditorPopUpPasteClipboardClick(Sender: TObject);
    procedure EditorPopUpClearClick(Sender: TObject);
    procedure EditorPopUpSelectAllClick(Sender: TObject);
    procedure bbTemplateToActiveWindowClick(Sender: TObject);
		Procedure GetWindowProc(WinHandle : HWND; bAllWindows : Boolean);
		Procedure GetWindows(bAllWindows : Boolean);
    procedure bbRefreshWindowsListClick(Sender: TObject);

    procedure cbDevTypeStandardClick(Sender: TObject);
    procedure lbDevTypesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbDevTypesKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbDevTypesClick(Sender: TObject);
		procedure lbDevTypesChange(Sender: TObject);
		procedure AddDT(Sender: TObject);
		procedure UpdateDT(Sender: TObject);
		procedure DeleteDT(Sender: TObject);
		procedure CopyDT(Sender: TObject);
		procedure AddTT(Sender: TObject);
		procedure UpdateTT(Sender: TObject);
		procedure DeleteTT(Sender: TObject);

    procedure TemplatesPopUpAddDTClick(Sender: TObject);
    procedure TemplatesPopUpUpdateDTClick(Sender: TObject);
    procedure TemplatesPopUpCopyDTClick(Sender: TObject);
    procedure TemplatesPopUpDeleteDTClick(Sender: TObject);
    procedure bbAddDTClick(Sender: TObject);
    procedure bbUpdateDTClick(Sender: TObject);
    procedure bbDeleteDTClick(Sender: TObject);
    procedure bbCopyDTClick(Sender: TObject);

    procedure TemplatesPopUpAddTTClick(Sender: TObject);
    procedure TemplatesPopUpUpdateTTClick(Sender: TObject);
    procedure TemplatesPopUpDeleteTTClick(Sender: TObject);
    procedure bbAddTTClick(Sender: TObject);
    procedure bbUpdateTTClick(Sender: TObject);
    procedure bbDeleteTTClick(Sender: TObject);

		//about
    procedure imAboutClick(Sender: TObject);
    procedure sgTemplateTypesExit(Sender: TObject);

  private
    { Private-Deklarationen }
		bAcceptEmptyNames : Boolean;
  public
    { Public-Deklarationen }
  end;

Var
	hTPlatorHandle : THandle;    	// Mutexhandle for TPlator
	sIniFile : String;           	//ini file with the main data
  sLngFile : String;						//language file containing the msgs and labels
  frmTemplates: TfrmTemplates;	//the main form
	sDevType : String;						//
	sTemplateFile : String;
	sTemplateType : String;
	sTemplateDir : String;
	iNoOfDevTypes : Integer;
	iNoOfTemplateTypes : Integer;
	sMemoFilename : String;
	nNoWindows : Integer;
	iDevTypeIndex : Integer;
	sOldDevType : String;
implementation

uses UAbout;

{$R *.DFM}

//
//TABSHEET TEMPLATES (1)
//

Procedure TfrmTemplates.GetWindowProc(WinHandle : HWND; bAllWindows : Boolean);
//get informations about a windows proc
//Parameter:
//
Var
  P : Array[0..256] Of Char;
Begin
  P[0] := #0;
  GetWindowText(WinHandle, P, 255);
  If (bAcceptEmptyNames Or (P[0] > #0)) Then
		Begin
			If bAllWindows = True Then
      Begin
				nNoWindows := nNoWindows + 1;
				cbWindowsList.Items.Append(String(P));
      End;
			If bAllWindows = False Then
      Begin
		    If IsWindowVisible(WinHandle) Or IsIconic(WinHandle) Then
	      Begin
  	    	nNoWindows := nNoWindows + 1;
	    	  cbWindowsList.Items.Append(String(P));
      	End;
      End;
		End;
End;

Procedure TfrmTemplates.GetWindows(bAllWindows : Boolean);
//gets all the active windows
Var
  WindowHandle2 : HWND;
Begin
  cbWindowsList.Clear;
  WindowHandle2 := FindWindow( Nil, Nil);
  GetWindowProc(WindowHandle2, False);
  While (WindowHandle2 <> 0) Do  // While there are still windows
    Begin
    WindowHandle2 := GetWindow(WindowHandle2, GW_HWNDNEXT);
    GetWindowProc(WindowHandle2, bAllWindows);
    End;
	cbWindowsList.ItemIndex := 0;
End;

procedure CreateTemplate(sFilename : String);
var
	F : TextFile;
begin
	{$I-}
	AssignFile(F, sFilename);ReWrite(F);
  {$I+}
	If IOResult <> 0 Then
		begin
		//ShowMessage(sFilename + ' kann nicht geffnet werden.');
		AppMsg(sLngFile, mtError, MSGFILENOTOPEN, sFilename, '');
    Exit;
		end;
	WriteLn(F, '');
	CloseFile(F);
end;

function TfrmTemplates.GetDevTypeIndex(sStr : String) : Integer;
//searches for a template int the stringgrid
var
 	i : Integer;
  iNumber : Integer;
  sTmp : String;
begin
	GetDevTypeIndex := 0;
	iNumber := Str2Int(IniGetValue(sIniFile, 'DevTypes', 'Number', '0'));
	If iNumber = 0 Then
  	Exit;
  for i := 1 to iNumber do
 	begin
		sTmp := IniGetValue(sIniFile, 'DevTypes', 'DevType' + Int2Str(i), '');
		if sTmp = sStr Then
			Begin
				GetDevTypeIndex := i;
				Exit;
			End;
 	end;
end;

function TfrmTemplates.FindDevType(sStr : String) : Integer;
//searches for a devtype in the listbox
var
 	i : Integer;
begin
	FindDevType := -1;
	With lbDevTypes Do
  	Begin
		  for i := 0 to Items.Count - 1 do
				if sStr = Items[i] Then
        	Begin
    			 	FindDevType := i;
            Exit
					End;
	 	End;
end;

function TfrmTemplates.FindTemplateType(sStr : String) : Boolean;
//searches for a template int the stringgrid
var
 	i : Integer;
begin
	FindTemplateType := False;
  for i := 1 to sgTemplateTypes.RowCount do
 	begin
		if sgTemplateTypes.Cells[1,i] = sStr Then
     	FindTemplateType := True;
 	end;
end;

//ini stuff
procedure TfrmTemplates.UpdateIni;
Var
	i : Integer;
  sKeyWord : String;
begin
	//update the options
	IniSetValue(sIniFile, 'Options', 'TemplateDir', edTemplateDir.Text);
	If cbReplaceAuthorInfo.Checked = True Then
		IniSetValue(sIniFile, 'Options', 'TemplateReplaceAuthorInfo', '1')
	Else
		IniSetValue(sIniFile, 'Options', 'TemplateReplaceAuthorInfo', '0');
	IniSetValue(sIniFile, 'Options', 'Name', edAuthorName.Text);
	IniSetValue(sIniFile, 'Options', 'EMail', edAuthorEMail.Text);
	IniSetValue(sIniFile, 'Options', 'EMail', edAuthorEMail.Text);

  //update DevTypes Section
	With lbDevTypes Do
  Begin
		IniSetValue(sIniFile, 'DevTypes', 'Number', Int2Str(Items.Count));
		IniSetValue(sIniFile, 'DevTypes', 'Standard', Int2Str(ItemIndex));
  	For i := 0 To Items.Count - 1 Do
			IniSetValue(sIniFile, 'DevTypes', 'DevType' + Int2Str(i + 1), Items[i]);
	End;

  //update the section
	with 	sgTemplateTypes Do
  begin
	  //number of templates
		If (RowCount = 2) And (Cells[1,1] = '') Then
	 		IniSetValue(sIniFile, sDevType, 'Number', Int2Str(0))
		Else
    	Begin
		    IniSetValue(sIniFile, sDevType, 'Number', Int2Str(RowCount - 1));
				//the template entries
				For i := 1 To sgTemplateTypes.RowCount - 1 Do
				Begin
					sKeyWord := 'Template' + Int2Str(i);
					If Cells[1,i] <> '' Then
						IniSetValue(sIniFile, sDevType, sKeyWord, Cells[1,i] + '#' + Cells[2,i]);
			  End;
			End;
	End;
end;

procedure TfrmTemplates.UpdateIniDevTypeSection(sDevType : String);
Var
	iOldNumber : Integer;
	i : Integer;
  sKeyWord : String;
begin
	//first get old number and delete template keys
	iOldNumber := Str2Int(IniGetValue(sIniFile, sDevType, 'Number', '0'));
	//
  If iOldNumber > 0 Then
  	Begin
    	For i := 1 To iOldNumber Do
      	IniDelKey(sIniFile, sDevType, 'Template' + Int2Str(i));
		End;
  //update the section
	with 	sgTemplateTypes Do
  begin
	  //number of templates
		If (RowCount = 2) And (Cells[1,1] = '') Then
	 		IniSetValue(sIniFile, sDevType, 'Number', Int2Str(0))
		Else
    	Begin
		    IniSetValue(sIniFile, sDevType, 'Number', Int2Str(RowCount - 1));
				//the template entries
				For i := 1 To sgTemplateTypes.RowCount - 1 Do
				Begin
					sKeyWord := 'Template' + Int2Str(i);
					If Cells[1,i] <> '' Then
						IniSetValue(sIniFile, sDevType, sKeyWord, Cells[1,i] + '#' + Cells[2,i]);
			  End;
			End;
	End;
end;

procedure TfrmTemplates.SetStringGrid;
//fill stringgrid with templateinfo from ini-file
Var
	i : Integer;
	sKeyWord : String;
Begin
 	iNoOfTemplateTypes := 0;
	With frmTemplates Do
  Begin
  //init
	sgTemplateTypes.ColCount := 3;
	//get number of templates
 	iNoOfTemplateTypes := Str2Int(IniGetValue(sIniFile, sDevType, 'Number', ''));
	If iNoOfTemplateTypes = 0 Then
  	Begin
			sgTemplateTypes.RowCount := 2;
			sgTemplateTypes.Cells[1,1] := '';
			sgTemplateTypes.Cells[2,1] := '';
			sTemplateType := '';
			sTemplateFile := '';
    	Exit;
    End;
	sgTemplateTypes.RowCount := iNoOfTemplateTypes + 1;
	//set rownumbers
	For i:= 1 To sgTemplateTypes.RowCount-1 Do
  	sgTemplateTypes.Cells[0,i] := Int2Str(i);
	//read templatetypes from ini-file and build stringgrid
	For i := 1 To iNoOfTemplateTypes Do
  Begin
		sKeyWord := 'Template' + Int2Str(i);
		sTemplateType := IniGetValue(sIniFile, sDevType, sKeyWord, '');
  	sTemplateFile := Copy(sTemplateType, Pos('#', sTemplateType) + 1, 255);
  	sTemplateType := Copy(sTemplateType, 1, Pos('#', sTemplateType) - 1);
		sgTemplateTypes.Cells[1,i] := sTemplateType;
		sgTemplateTypes.Cells[2,i] := sTemplateFile;
	End;
	//set focus to 1,1
	sgTemplateTypes.Row := 1;
	sgTemplateTypes.Col := 1;
	sTemplateType := sgTemplateTypes.Cells[1,1];
	sTemplateFile := sgTemplateTypes.Cells[1,2];
	Caption := PGMNAME + sDevType + ':' + sTemplateType + ' - ' + sTemplateFile;
	If CheckFile(sTemplateDir + sTemplateFile) = False then
	begin
		//template not found. handling or messaging here possible
		//AppMsg(sLngFile, mtError, MSGFILENOTFOUND, sTemplateDir + sTemplateFile, '');
    //Halt;
	end;
	End;
End;

function GetDevTypeKeyFromIni(sDevType : String) : Integer;
//return the keyindex of the devtype from the ini-file
Var
	i, iNoOfDevTypes : Integer;
	sTmp : String;
Begin
	//anzahl devtypes
	iNoOfDevTypes := Str2Int(IniGetValue(sIniFile, 'DevTypes', 'Number', ''));
	If iNoOfDevTypes = 0 Then
  	Begin
			GetDevTypeKeyFromIni := 0;
    	Exit;
		End;
	//search
	For i := 1 To iNoOfDevTypes Do
	 begin
		sTmp := IniGetValue(sIniFile, 'DevTypes', 'DevType' + Int2Str(i), '');
		If StrComp(PChar(sTmp), PChar(sDevType)) = 0 Then
		Begin
			GetDevTypeKeyFromIni := i;
    	Exit;
		End;
	End;
	GetDevTypeKeyFromIni := 0;
End;

//
//Set Routines
//
procedure TfrmTemplates.SetStatusBar;
begin
	sbTemplates.Panels[0].Text := sDevType;
  sbTemplates.Panels[1].Text := sTemplateType;
  sbTemplates.Panels[2].Text := PGMNAME + PGMCOPYRIGHT;
  sbTemplates.Panels[3].Text := DateToStr(Now);
end;

procedure TfrmTemplates.SetDevTypes(Sender : TObject);
//fill combobox with devtypes from Inifile
Var
	i, nStandard : Integer;
Begin
	With frmTemplates Do
  Begin
		lbDevTypes.Clear;
		//IniFile lesen und werte setzen
		//standard
		nStandard := Str2Int(IniGetValue(sIniFile, 'DevTypes', 'Standard', ''));
		//anzahl devtypes
  	iNoOfDevTypes := Str2Int(IniGetValue(sIniFile, 'DevTypes', 'Number', ''));
		If iNoOfDevTypes = 0 Then
    	Exit;
		//build listbox
		For i := 1 To iNoOfDevTypes Do
		  begin
      lbDevTypes.Items.Append(IniGetValue(sIniFile, 'DevTypes', 'DevType' + Int2Str(i), ''));
	  	end;
	  lbDevTypes.ItemIndex := nStandard - 1;
		sDevType := lbDevTypes.Items[lbDevTypes.ItemIndex];
		edDevType.Text := sDevType;
    edDevTypeComment.Text := IniGetValue(sIniFile, sDevType, 'Comment', '');
	End;
End;

procedure TfrmTemplates.SetTemplateTypes(Sender : TObject);
//fill the various field with info
Begin
 	iNoOfTemplateTypes := 0;
	With frmTemplates Do
  Begin
  //init
 	mmTemplate.Lines.Clear;
	sTemplateType := '';
	sTemplateFile := '';
	SetStringGrid(Sender);
	End
End;

procedure TfrmTemplates.ReadIni(Sender: TObject);
//reads the two inifiles:
//1) contains the template structure
//2) sets the language
begin
	//check inifiles for data and language
	sIniFile := CheckIni(PGMINIFILE);
	If sIniFile = '' Then
  begin
  	AppMsg(sLngFile, mtError, MSGFILENOTFOUND, sIniFile, '');
    Halt;
	end;
	//languagefile is set in ini-file
	sLngFile := IniGetValue(sIniFile, 'Options', 'LanguageFile', PGMLNGFILE);
	sLngFile := CheckIni(sLngFile);
	If sLngFile = '' Then
  begin
  	AppMsg(sLngFile, mtError, MSGFILENOTFOUND, sLngFile, '');
    Halt;
	end;
  //set text and headings
  //these are stored in the *.lng file

	bbOK.Caption := IniGetValue(sLngFile, 'Global', 'OK', 'OK');
	bbHelp.Caption := IniGetValue(sLngFile, 'Global', 'Help', 'Help');

	//template tabsheet (1)
	tsTemplates.Caption := IniGetValue(sLngFile, 'Templates', 'Caption', 'Templates');
	lblDevType.Caption := IniGetValue(sLngFile, 'Templates', 'DevTypes', 'DevTypes');
	bbAddDT.Caption := IniGetValue(sLngFile, 'Templates', 'DevTypeAdd', 'Add');
	bbUpdateDT.Caption := IniGetValue(sLngFile, 'Templates', 'DevTypeUpdate', 'Upd');
	bbCopyDT.Caption := IniGetValue(sLngFile, 'Templates', 'DevTypeCopy', 'Copy');
	bbDeleteDT.Caption := IniGetValue(sLngFile, 'Templates', 'DevTypeDelete', 'Del');
	cbDevTypeStandard.Caption := IniGetValue(sLngFile, 'Templates', 'DevTypeStandard', 'Standard');
	lblDevTypeComment.Caption := IniGetValue(sLngFile, 'Templates', 'DevTypeComment', 'Comment');
	lblTemplateType.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateType', 'TemplateType');
	lblTemplateCopy.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateCopy', 'TemplateCopy');
	lblWindowsList.Caption :=  IniGetValue(sLngFile, 'Templates', 'WindowsList', 'List of Windows');
	bbTemplateEdit.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateEdit', 'Edit');
	bbTemplateToClipboard.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateToClipboard', 'Clip');
	bbTemplateToActiveWindow.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateToActiveWindow', 'Window');
	bbAddTT.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateAdd', 'Add');
	bbUpdateTT.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateUpdate', 'Add');
	bbUpdateTT.Visible := False;
	bbDeleteTT.Caption := IniGetValue(sLngFile, 'Templates', 'TemplateDelete', 'Add');
	lblIniFile.Caption := IniGetValue(sLngFile, 'Templates', 'IniFile', 'IniFile');
	bbIniEdit.Caption := IniGetValue(sLngFile, 'Templates', 'IniEdit', 'Edit');
	bbIniReload.Caption := IniGetValue(sLngFile, 'Templates', 'IniReload', 'Reload');
	lbDevTypes.Sorted := True;
  //stringgrid for templatetypes
	sgTemplateTypes.ColCount := 3;
	sgTemplateTypes.Scrollbars := ssVertical;
	sgTemplateTypes.ColWidths[0] := 20;
	sgTemplateTypes.ColWidths[1] := 180;
	sgTemplateTypes.ColWidths[2] := 150;
	sgTemplateTypes.Cells[0,0] := IniGetValue(sLngFile, 'Templates', 'GridColumn1', 'Nr');
	sgTemplateTypes.Cells[1,0] := IniGetValue(sLngFile, 'Templates', 'GridColumn2', 'Type');
	sgTemplateTypes.Cells[2,0] := IniGetValue(sLngFile, 'Templates', 'GridColumn3', 'File');
	sgTemplateTypes.Options := [goFixedVertLine, goFixedHorzLine, goHorzLine, goVertLine,goDrawFocusSelected, goEditing, goTabs];

	//options tabsheet (2)
	tsOptions.Caption := IniGetValue(sLngFile, 'Options', 'Caption', 'Options');
	lblAuthor.Caption := IniGetValue(sLngFile, 'Options', 'Author', 'Author');
	lblAuthorName.Caption := IniGetValue(sLngFile, 'Options', 'Name', 'Name');
	lblAuthorEMail.Caption := IniGetValue(sLngFile, 'Options', 'EMail', 'EMail');
	lblAuthorWebSite.Caption := IniGetValue(sLngFile, 'Options', 'WebSite', 'WebSite');
	cbReplaceAuthorInfo.Caption:=IniGetValue(sLngFile, 'Options', 'ReplaceAuthorInfo', 'ReplaceAuthorInfo');
	lblTemplateDir.Caption := IniGetValue(sLngFile, 'Options', 'TemplateDir', 'TemplateDir');
	edTemplateDir.Text := IniGetValue(sIniFile, 'Options', 'TemplateDir', 'TemplateDir');
	lblVarious.Caption := IniGetValue(sLngFile, 'Options', 'Various', 'Various');
	lblLanguageFile.Caption := IniGetValue(sLngFile, 'Options', 'LanguageFile', 'LanguageFile');
	edLanguageFile.Text := sLngFile;
  bbSaveOptions.Caption := IniGetValue(sLngFile, 'Options', 'SaveOptions', 'Save Option');

	//editor tabsheet
	tsEditor.Caption:=IniGetValue(sLngFile, 'Editor', 'Caption', 'Editor');
	lblMemoFile.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoFileLabel', 'File:');
	bbMemoNew.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoNew', '&New');
	bbMemoOpen.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoOpen', '&Open');
	bbMemoSave.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoSave', '&Save');
	bbMemoSaveAs.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoSaveAs', 'Save &as');
	bbMemoPrint.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoPrint', '&Print');
	bbMemoPrintSetup.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoPrintSetup', 'Printse&t');
	lblMemoFind.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoFindLabel', 'Find');
	bbMemoFind.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoFind', '&Find');
	lblMemoReplace.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoReplace', 'Replace');
	bbMemoReplace.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoReplace', '&Replace');
	cbMemoFModified.Caption:=IniGetValue(sLngFile, 'Editor', 'MemoModified', 'Modified');

	//sets the values
	//Author
  edAuthorName.Text := IniGetValue(sIniFile, 'Options', 'Name', 'Author');
  edAuthorEMail.Text := IniGetValue(sIniFile, 'Options', 'EMail', 'Author@mail.com');
  edAuthorWebSite.Text := IniGetValue(sIniFile, 'Options', 'WebSite', 'http://www.AuthorWebSite.com');
	//template
	sTemplateDir := IniGetValue(sIniFile, 'Options', 'TemplateDir', 'Template\');
	//languagefile
	edLanguageFile.Text := IniGetValue(sIniFile, 'Options', 'LanguageFile', 'tplator.lng');
  //devtypes
	SetDevTypes(Sender);
	//templates
	SetTemplateTypes(Sender);
  If Str2Int(IniGetValue(sIniFile, 'DevTypes', 'Standard', '0')) = lbDevTypes.ItemIndex + 1 Then
		cbDevTypeStandard.Checked := True
end;

//FORMCREATE und CLOSE

procedure TfrmTemplates.FormCreate(Sender: TObject);
var
	sTmp : String;
	nIdx : Integer;
begin
	//set activepage, t.i. tabsheet 1
	pcTPlator.ActivePage := tsTemplates;
	//read the ini
	ReadIni(Sender);
	//clearmemo in tabsheet 3
  Memo1.Clear;
	//check on parameter
  //parameter autocopy sets the default devtype and template and copies
  //the content of the template to the clipboard
  if ParamCount > 0 then
  begin
	  sTmp := IniGetValue(sIniFile, 'Options', 'AutoCopy', '');
		If sTmp <> '' Then
    Begin
    	nIdx := FindDevType(Copy(sTmp, 1, Pos('.', sTmp) - 1));
      If nIdx >= 0 Then
			Begin
				lbDevTypes.ItemIndex := nIdx;
				lbDevTypesChange(Sender);
				nIdx := Str2Int(Copy(sTmp, Pos('.', sTmp) + 1, 255));
				If nIdx <= sgTemplateTypes.RowCount Then
					sgTemplateTypes.Row := nIdx
				Else
					sgTemplateTypes.Row := sgTemplateTypes.RowCount;
			End;
	    if ParamStr(1) = '/c' then
				bbTemplateToClipboardClick(Sender);
    	//if ParamStr(1) = '/w' then
			//	bbTemplateToActiveWindowClick(Sender);
    End;
  end;
  //execute events
	pcTPlatorChange(Sender);
	//GetAllWindows
	GetWindows(False);
	//fill stringgrid
	sgTemplateTypesClick(Sender);
	//lbDevTypes.SetFocus;
  //update the Statusbar
	SetStatusBar(Sender);
end;

procedure TfrmTemplates.bbOKClick(Sender: TObject);
Var
	CanClose : Boolean;
begin
 	//UpdateIniDevTypeSection(sDevType);
	FormCloseQuery(Self, CanClose);
	If CanClose Then Close;
end;

procedure TfrmTemplates.bbHelpClick(Sender: TObject);
begin
	Application.HelpJump('');
  //AppMsg(sLngFile,mtInformation, MSGINPREP, sTemplateFile, '');
end;

procedure TfrmTemplates.ReplaceDialog1Replace(Sender: TObject; sFindText : String; sReplaceText : String);
//replace is used to replace keywords in templates
//the keywords are defined in the options section of the ini-file
//example: %Date wird ersetzt in 28.12.2000
var
  SelPos: Integer;
begin
  with TReplaceDialog(Sender) do
  begin
		ReplaceDialog1.FindText := sFindText;
		ReplaceDialog1.ReplaceText := sReplaceText;
    { Globale, schreibweisensensitive Suche nach FindText in Memo }
    SelPos := Pos(ReplaceDialog1.FindText, mmTemplate.Lines.Text);
    if SelPos > 0 then
    begin
      mmTemplate.SelStart := SelPos - 1;
      mmTemplate.SelLength := Length(ReplaceDialog1.FindText);
      { Markierten Text durch ReplaceText ersetzen }
      mmTemplate.SelText := ReplaceDialog1.ReplaceText;
    end
    else
	    //MessageDlg(Format(MSGTEXTNOTFOUND, [sFindText]), mtError, [mbOk], 0);
  end;
end;

procedure TfrmTemplates.bbTemplateEditClick(Sender: TObject);
begin
	//check if template is there
	if CheckFile(sIniFile) = False then
  begin
  	AppMsg(sLngFile, mtError, MSGFILENOTFOUND, sIniFile, '');
		Exit;
	end;
  if sTemplateFile = '' Then Exit;
	//open the template
  if MemoOpen(sTemplateDir + sTemplateFile) = True Then
		sgTemplateTypesClick(Sender);
end;

procedure TfrmTemplates.bbIniEditClick(Sender: TObject);
begin
	//ini-datei lesen und prfen ob vorhanden
	if CheckFile(sIniFile) = False then
  begin
  	AppMsg(sLngFile, mtError, MSGFILENOTFOUND, sIniFile, '');
		Exit;
	end;
  MemoOpen(sIniFile);
end;

procedure TfrmTemplates.bbIniReloadClick(Sender: TObject);
begin
	//leseiniwerte
	ReadIni(Sender);
end;

procedure TfrmTemplates.bbTemplateToClipboardClick(Sender: TObject);
begin
	mmTemplate.SelectAll;
	If Length(mmTemplate.SelText) > 0 Then
  	Begin
		  mmTemplate.CopyToClipboard;
	    //MessageDlg(Format(MSGTEMPLATETOCLIP, [sTemplateFile]), mtConfirmation, [mbOK], 0);
		End;
end;

procedure TfrmTemplates.mmTemplateChange(Sender: TObject);
begin
	mmTemplate.Modified := True;
end;

procedure TfrmTemplates.cbDevTypeStandardClick(Sender: TObject);
begin
	If cbDevTypeStandard.Checked = True Then
		IniSetValue(sIniFile, 'DevTypes', 'Standard', Int2Str(lbDevtypes.ItemIndex + 1));
end;

procedure TfrmTemplates.sgTemplateTypesExit(Sender: TObject);
begin
	with sgTemplateTypes do
		sTemplateFile := Cells[2,Row];
	UpdateIniDevTypeSection(sDevType);
end;

//
//TABSHEET AUTHORINFO (2)
//

procedure TfrmTemplates.bbSaveOptionsClick(Sender: TObject);
//speichert authoreninfo in inifile
begin
	IniSetValue(sIniFile, 'Options', 'Name', edAuthorName.Text);
	IniSetValue(sIniFile, 'Options', 'EMail', edAuthorEMail.Text);
	IniSetValue(sIniFile, 'Options', 'WebSite', edAuthorWebSite.Text);
	IniSetValue(sIniFile, 'Options', 'TemplateDir', edTemplateDir.Text);
  If cbReplaceAuthorInfo.Checked = TRUE Then
		IniSetValue(sIniFile, 'Options', 'TemplateReplaceAuthorInfo', '1')
	Else
		IniSetValue(sIniFile, 'Options', 'TemplateReplaceAuthorInfo', '0');
	IniSetValue(sIniFile, 'Options', 'LanguageFile', edLanguageFile.Text);
end;

//
//TABSHEET EDITOR (3)
//

procedure TfrmTemplates.Memo1Enter(Sender: TObject);
begin
	If sMemoFilename = '' Then
  	sMemoFilename := AppStr(sLngFile, MSGDEFFILE, '', '');
end;

function TfrmTemplates.MemoOpen(const AFilename: string) : Boolean;
var
  nDialogValue: Integer;
begin
	if CheckFile(AFilename) = False then
		begin
		nDialogValue := AppDlg(sLngFile, MSGNEWTEMPLATE, AFileName, '');
    case nDialogValue of
      id_Yes: CreateTemplate(AFilename);
      id_No: begin MemoOpen := False; Exit; End
    end;
  end;
  sMemoFileName := AFilename;
  Memo1.Lines.LoadFromFile(sMemoFileName);
  Memo1.SelStart := 0;
  Caption := PGMNAME + sDevType + ':' + ExtractFileName(sMemoFileName);
  Memo1.Modified := False;
	cbMemoFModified.Checked := Memo1.Modified;
	pcTPlator.ActivePage := tsEditor;
	MemoOpen := True;
end;

procedure TfrmTemplates.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	cbMemoFModified.Checked := Memo1.Modified;
  Action := caFree;
end;

procedure TfrmTemplates.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  nDialogValue: Integer;
  FName: string;
begin
	CanClose := TRUE;
  if Memo1.Modified then
  begin
    FName := sMemoFilename;
		nDialogValue := AppDlg(sLngFile, MSGFILESAVEAS, FName, '');
    case nDialogValue of
      id_Yes: bbMemoSaveAsClick(Self);
      id_Cancel: CanClose := False;
    end;
  end;
end;

//
//Buttons
//
procedure TfrmTemplates.bbMemoNewClick(Sender: TObject);
var
	bCanClose : Boolean;
begin
	FormCloseQuery(Sender, bCanClose);
	If bCanClose Then
  	begin
	  Memo1.Lines.Clear;
  	Memo1.SelStart := 0;
    sMemoFilename := AppStr(sLngFile, MSGDEFFILE, '', '');
	  Caption := PGMNAME + sDevType + ':' + ExtractFileName(sMemoFileName);
	  Memo1.Modified := False;
		cbMemoFModified.Checked := Memo1.Modified;
		//pcTPlator.ActivePage := tsEditor;
    end;
end;

procedure TfrmTemplates.bbMemoOpenClick(Sender: TObject);
var
	bCanClose : Boolean;
begin
	FormCloseQuery(Sender, bCanClose);
	If bCanClose Then
  	begin
		  if MemoOpenDialog1.Execute then
			  begin
			 	sMemoFilename := MemoOpenDialog1.Filename;
				MemoOpen(sMemoFilename);
	  		end;
		end;
end;

procedure TfrmTemplates.bbMemoSaveClick(Sender: TObject);

  procedure CreateBackup(const Filename: string);
  var
    BackupFilename: string;
  begin
    BackupFilename := ChangeFileExt(Filename, AppStr(sLngFile, DEFBACKUPEXT, '', ''));
    DeleteFile(BackupFilename);
    RenameFile(Filename, BackupFilename);
  end;

  function IsReadOnly(const Filename: string): Boolean;
  begin
    Result := Boolean(FileGetAttr(Filename) and faReadOnly);
    if Result then
    	AppMsg(sLngFile,mtWarning, MSGFILEREADONLY, ExtractFilename(Filename), '');
  end;

begin
  if (sMemoFilename = '') or IsReadOnly(sMemoFilename) then
    bbMemoSaveAsClick(Sender)
  else
  begin
    CreateBackup(sMemoFilename);
    Memo1.Lines.SaveToFile(sMemoFilename);
    Memo1.Modified := False;
		cbMemoFModified.Checked := Memo1.Modified;
		sgTemplateTypesClick(Sender);
  end;
end;

procedure TfrmTemplates.bbMemoSaveAsClick(Sender: TObject);
begin
  MemoSaveDialog1.DefaultExt := '.txt';
  MemoSaveDialog1.Filename := sMemoFilename;
  if MemoSaveDialog1.Execute then
  begin
    sMemoFilename := MemoSaveDialog1.Filename;
    Caption := PGMNAME + sDevType + ':' + ExtractFileName(sMemoFilename);
    bbMemoSaveClick(Sender);
  end;
end;

procedure TfrmTemplates.bbMemoPrintClick(Sender: TObject);
var
  Line: Integer;
  PrintText: System.Text;
begin
  if MemoPrintDialog1.Execute then
  begin
    AssignPrn(PrintText);
    Rewrite(PrintText);
    Printer.Canvas.Font := Memo1.Font;
    for Line := 0 to Memo1.Lines.Count - 1 do
      Writeln(PrintText, Memo1.Lines[Line]);
    System.Close(PrintText);
  end;
end;

procedure TfrmTemplates.bbMemoPrintSetupClick(Sender: TObject);
begin
  MemoPrinterSetupDialog1.Execute;
end;

procedure TfrmTemplates.bbMemoSelectAllClick(Sender: TObject);
begin
  Memo1.SelectAll;
end;

procedure TfrmTemplates.bbMemoPasteFromClipboardClick(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TfrmTemplates.bbMemoCutToClipboardClick(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

procedure TfrmTemplates.bbMemoCopyToClipboardClick(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

procedure TfrmTemplates.Memo1Change(Sender: TObject);
begin
    Memo1.Modified := True;
   	cbMemoFModified.Checked := Memo1.Modified;
		//lblCurPos.Caption := 'X:' + Int2Str(Memo1.CaretPos.X + 1) + ' ' + 'Y:' + Int2Str(Memo1.CaretPos.Y + 1);
end;

procedure TfrmTemplates.MemoFindDialogFind(Sender: TObject; sFindText : String);
var
  SelPos: Integer;
begin
  with TFindDialog(Sender) do
  begin
		MemoFindDialog.FindText := sFindText;
    //FindDialog1.Options := [frDown, frDisableMatchCase, frDisableWholeWord];
    { Globale, schreibweisensensitive Suche nach FindText in Memo }
    SelPos := Pos(UpperCase(MemoFindDialog.FindText), UpperCase(Memo1.Lines.Text));
    //SelPos := Pos(FindDialog1.FindText, Memo1.Lines.Text);
    if SelPos > 0 then
    begin
      Memo1.SetFocus;
      Memo1.SelStart := SelPos - 1;
      Memo1.SelLength := Length(MemoFindDialog.FindText);
    end
    else
	    AppMsg(sLngFile,mtError, MSGTEXTNOTFOUND, MemoFindDialog.FindText, '');
  end;
end;

procedure TfrmTemplates.MemoReplaceDialogReplace(Sender: TObject; sFindText : String; sReplaceText : String);
var
  SelPos: Integer;
begin
  with TReplaceDialog(Sender) do
  begin
		MemoReplaceDialog.FindText := sFindText;
		MemoReplaceDialog.ReplaceText := sReplaceText;
    { Globale, schreibweisensensitive Suche nach FindText in Memo }
    SelPos := Pos(ReplaceDialog1.FindText, Memo1.Lines.Text);
    if SelPos > 0 then
    begin
      Memo1.SelStart := SelPos - 1;
      Memo1.SelLength := Length(MemoReplaceDialog.FindText);
      { Markierten Text durch ReplaceText ersetzen }
      Memo1.SelText := MemoReplaceDialog.ReplaceText;
    end
    else
	    AppMsg(sLngFile,mtError, MSGTEXTNOTFOUND, MemoReplaceDialog.FindText, '');
  end;
end;

procedure TfrmTemplates.bbMemoFindClick(Sender: TObject);
begin
	If edMemoFind.Text <> '' Then
		MemoFindDialogFind(Sender, edMemoFind.Text);
end;

procedure TfrmTemplates.bbMemoReplaceClick(Sender: TObject);
begin
	If edMemoFind.Text <> '' Then
		MemoReplaceDialogReplace(Sender, edMemoFind.Text, edMemoReplace.Text);
end;

procedure TfrmTemplates.pcTPlatorChange(Sender: TObject);
//pagecontrol nderungen. abhngig vom tabsheet wird die
//berschrift gesetzt
begin
	If pcTPlator.ActivePage = tsTemplates Then
		Caption := PGMNAME + sDevType + ':' + sTemplateType + ' - ' + sTemplateFile;
	If pcTPlator.ActivePage = tsOptions Then
		Caption := PGMNAME + edAuthorName.Text;
	If pcTPlator.ActivePage = tsEditor Then
		begin
		If sMemoFilename = '' Then
    	Caption := PGMNAME + AppStr(sLngFile, MSGNOFILE, '', '');
		If sMemoFilename <> '' Then Caption := PGMNAME + sMemoFilename;
    end;
end;

procedure TfrmTemplates.bbClearMemoClick(Sender: TObject);
begin
	Memo1.Lines.Clear;
end;

procedure TfrmTemplates.bbInsertDTClick(Sender: TObject);
var
	x,y : Integer;
	sLine, sNewLine : String;
begin
	x := Memo1.CaretPos.X;
	y := Memo1.CaretPos.Y;
	//lblCurPos.Caption := 'X:' + Int2Str(Memo1.CaretPos.X + 1) + ' ' + 'Y:' + Int2Str(Memo1.CaretPos.Y + 1);
	sLine := Memo1.Lines[y];
	sNewLine := Copy(sLine, 0, x) + DateToStr(Now) + Copy(sLine, x + 1, Length(sLine) - x);
	Memo1.Lines[y] := sNewLine;
	//Memo1.Lines.Insert(y, DateToStr(Now));
  //Memo1.Lines.Count
end;

procedure TfrmTemplates.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
		lblCurPos.Caption := 'X:' + Int2Str(Memo1.CaretPos.X + 1) + ' ' + 'Y:' + Int2Str(Memo1.CaretPos.Y + 1);
end;

procedure TfrmTemplates.EditorPopUpInsertDateandTimeClick(Sender: TObject);
var
	x,y : Integer;
	sLine, sNewLine : String;
begin
	x := Memo1.CaretPos.X;
	y := Memo1.CaretPos.Y;
	sLine := Memo1.Lines[y];
	sNewLine := Copy(sLine, 0, x) + DateToStr(Now) + Copy(sLine, x + 1, Length(sLine) - x);
	Memo1.Lines[y] := sNewLine;
end;

procedure TfrmTemplates.EditorPopUpInsertAuthorinfoClick(Sender: TObject);
var
	x,y : Integer;
	sLine, sNewLine : String;
begin
	x := Memo1.CaretPos.X;
	y := Memo1.CaretPos.Y;
	sLine := Memo1.Lines[y];
	sNewLine := Copy(sLine, 0, x) +
							IniGetValue(sIniFile, 'Options', 'Name', 'Author') + ' ' +
  						IniGetValue(sIniFile, 'Options', 'EMail', 'Author') + ' ' +
              DateToStr(Date) + ' ' +
						  Copy(sLine, x + 1, Length(sLine) - x);
	Memo1.Lines[y] := sNewLine;
end;

procedure TfrmTemplates.pmEditorPopup(Sender: TObject);
begin
with Memo1 Do
begin
end;

end;

procedure TfrmTemplates.EditorPopUpCopyClipboardClick(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

procedure TfrmTemplates.EditorPopUpCutClipboardClick(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

procedure TfrmTemplates.EditorPopUpPasteClipboardClick(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TfrmTemplates.EditorPopUpClearClick(Sender: TObject);
var
	nSelLength : Integer;
begin
	Memo1.SetFocus;
  Memo1.SelectAll;
	nSelLength := Memo1.SelLength;
  Memo1.Clear;
	If nSelLength > 0 Then
  	begin
    Memo1.Modified := True;
   	cbMemoFModified.Checked := Memo1.Modified;
    end;
end;

procedure TfrmTemplates.EditorPopUpSelectAllClick(Sender: TObject);
begin
  Memo1.SelectAll;
end;

//
//SEND CHARS/LINES TO ANOTHER APP
//
function SendLineToApp(hWndParent : Integer; sLine : String; bCRLF : Boolean) : Boolean;
var
	hWndChild, i, sLen : Integer;
begin
	If hWndParent = 0 Then
  Begin
		SendLineToApp := False;
    Exit;
	End;
	If IsIconic(hWndParent) Then ShowWindow(hWndParent, SW_RESTORE);
	{Find the window of the application's text box}
	hWndChild := ChildWindowFromPoint(hWndParent, point(50,50));
	//ShowMessage(Int2Str(hWndChild) + '#' + Int2Str(hWndParent));
	If hWndChild = 0 Then
  	Begin
			SendLineToApp := False;
	    Exit;
    End;
	//SetForegroundWindow(hWndChild);
	//SetFocus(hWndChild);
  sLen := Length(sLine);
  If sLen = 0 Then
  Begin
		SendLineToApp := False;
	  Exit;
  End;
  {Now send it a character!!}
	For i := 1 To sLen Do
  	SendMessage(hWndChild, WM_CHAR, Ord(sLine[i]), 0);
	If bCRLF Then
		SendMessage(hWndChild, WM_CHAR, 13, 0);
	SendLineToApp := True;
end;

procedure TfrmTemplates.bbTemplateToActiveWindowClick(Sender: TObject);
//pastes the content of the template direct into an active window
Var
	hWndParent : Integer;
	hWndChild : Integer;
	sWindow : String;
begin
	sWindow := '';
	//only do something when windows are available in the windows combobox
	If cbWindowsList.ItemIndex > 0 Then
		Begin
			sWindow := cbWindowsList.Items[cbWindowsList.ItemIndex];
			//searches the selected window and returns a handle to it
		 	hWndParent := FindWindow(nil, PChar(sWindow));
			//no handle found
			If hWndParent = 0 Then
  		Begin
		    AppMsg(sLngFile,mtError, MSGWINDOWNOTFOUND, sWindow, '');
		    Exit;
	    End;
			//copy the template also to the clipboard
			bbTemplateToClipboardClick(Sender);
			//if window is iconised, restore it to its original size
			If IsIconic(hWndParent) Then
      	ShowWindow(hWndParent, SW_RESTORE);
			//searches for childwindows
			hWndChild := ChildWindowFromPoint(hWndParent, point(50,50));
			//no child window
			If hWndChild = 0 Then
  		Begin
		    AppMsg(sLngFile,mtError, MSGWINDOWNOTFOUND, sWindow, '');
		    Exit;
			End;
			If IsWindowEnabled(hWndChild) = False Or IsWindowVisible(hWndChild) = False Then
  		Begin
		    AppMsg(sLngFile,mtError, MSGWINDOWNOTFOUND, sWindow, '');
		    Exit;
			End;
			//various possibilities to paste text
      //best option is using the keystroke ctrl-V (strg-v)
      //before sending the string, the cursor must be placed in an editable part
      //of the target window
			//put focus to selected window. if not no keystrokes are accepted.
			SetForegroundWindow(hWndChild);
			//send ctrl-v (=paste)
			PostKeyEx32(ORD('V'), [ssCtrl], FALSE);
			//using sendmessage(hWndChild, WM_PASTE, 0,0) does not work in all cases
			//still lokiking for a way to do so
		End
	Else
		AppMsg(sLngFile,mtError, MSGNOWINDOWS, sWindow, '');
end;

procedure TfrmTemplates.bbRefreshWindowsListClick(Sender: TObject);
begin
	GetWindows(False);
end;

//
//Listbox lbDevTypes
//

procedure TfrmTemplates.lbDevTypesChange(Sender: TObject);
begin
 	UpdateIniDevTypeSection(sDevType);
	iDevTypeIndex := lbDevTypes.ItemIndex;
	sDevType := lbDevTypes.Items[lbDevTypes.ItemIndex];
	edDevType.Text := sDevType;
  edDevTypeComment.Text := IniGetValue(sIniFile, sDevType, 'Comment', '');
  If Str2Int(IniGetValue(sIniFile, 'DevTypes', 'Standard', '0')) = lbDevTypes.ItemIndex + 1 Then
		cbDevTypeStandard.Checked := True
	Else
		cbDevTypeStandard.Checked := False;
	SetTemplateTypes(Sender);
	SetStringGrid(Sender);
	sgTemplateTypesClick(Sender);
	SetStatusBar(Sender);
end;

procedure TfrmTemplates.lbDevTypesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	lbDevTypesChange(Sender);
end;

procedure TfrmTemplates.lbDevTypesKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	lbDevTypesChange(Sender);
end;

procedure TfrmTemplates.lbDevTypesClick(Sender: TObject);
begin
	lbDevTypesChange(Sender);
end;

procedure TfrmTemplates.AddDT(Sender: TObject);
var
	i : Integer;
begin
	If edDevType.Text = '' Then
  	Exit;
	With lbDevTypes Do
  	Begin
			//check if entry is already there
		  for i := 0 to Items.Count - 1 Do
		  	if Text = Items[i] Then
		    	Exit;
			//add
	  	Items.Add(edDevType.Text);
			//Update Section DevTypes
 		 	IniSetValue(sIniFile, 'DevTypes', 'DevType' + Int2Str(Items.Count), edDevType.Text);
	    IniSetValue(sIniFile, 'DevTypes', 'Number', Int2Str(Items.Count));
    End;
end;

procedure TfrmTemplates.UpdateDT(Sender: TObject);
var
	i : Integer;
	iActIndex : Integer;
  sOldDevType : String;
  iDevTypeIndex : Integer;
begin
	iActIndex := lbDevTypes.ItemIndex;
	sOldDevType := lbDevTypes.Items[lbDevTypes.ItemIndex];
	iDevTypeIndex := GetDevTypeIndex(sOldDevType);
	If (edDevType.Text = '') Or (iDevTypeIndex = 0) Then
  	Exit;
	With lbDevTypes Do
  	Begin
			//check if entry is already there
		  for i := 0 to Items.Count - 1 Do
		  	if Text = Items[i] Then
		    	Exit;
			//update
	  	Items[iActIndex] := edDevType.Text;
      //update inifile
			With sgTemplateTypes Do
				Begin
					For i := 1 To RowCount - 1 Do
  	      	IniSetValue(sIniFile, Items[iActIndex], 'Template' + Int2Str(i), Cells[1,i] + '#' + Cells[2,i]);
    		 	IniSetValue(sIniFile, Items[iActIndex], 'Number', Int2Str(RowCount - 1));
				End;
			//delete the old section
 		 	IniDelSection(sIniFile, sOldDevType);
			//Update Section DevTypes
 		 	IniSetValue(sIniFile, 'DevTypes', 'DevType' + Int2Str(iDevTypeIndex), edDevType.Text);
	    IniSetValue(sIniFile, sDevType, 'Comment', edDevTypeComment.Text);
    End;
end;

procedure TfrmTemplates.DeleteDT(Sender: TObject);
Var
	sOldDevType : String;
  iIndex : Integer;
	i, iNoOfDevTypes : Integer;
begin
	//
	sOldDevtype := sDevType;
	If sOldDevType = '' Then Exit;
  With lbDevTypes Do
  	Begin
			Items.Delete(ItemIndex);
    End;
	//clear stringgrid
	sgTemplateTypes.RowCount := 2;
	sgTemplateTypes.Cells[1, 1] := '';
	sgTemplateTypes.Cells[2, 1] := '';
	//update inifile
  //remove key from devtype section
  //first get the index from the section
	iIndex := GetDevTypeKeyFromIni(sOldDevType);
	If iIndex > 0 Then
		IniDelKey(sIniFile, 'DevTypes', 'DevType' + Int2Str(iIndex));
	//remove section
  IniDelSection(sIniFile, sOldDevType);
	//update the devtype section again
	iNoOfDevTypes := lbDevTypes.Items.Count;
	IniSetValue(sIniFile, 'DevTypes', 'Number', Int2Str(iNoOfDevTypes));
	If iNoOfDevTypes = 0 Then
	Begin
		Exit;
  End;
	//delete all old entries. therefor one more
	For i := 1 To iNoOfDevTypes + 1 Do
		IniDelKey(sIniFile, 'DevTypes', 'DevType' + Int2Str(i));
	For i := 0 To lbDevTypes.Items.Count - 1 Do
		IniSetValue(sIniFile, 'DevTypes', 'DevType' + Int2Str(i + 1), lbDevTypes.Items[i]);
end;

procedure TfrmTemplates.CopyDT(Sender: TObject);
var
	i : Integer;
	iActIndex : Integer;
begin
	If edDevType.Text = '' Then
  	Exit;
	//add the devtype to the devtypes section
	AddDT(Sender);
	//set the new devtype as selected
	iActIndex := FindDevType(edDevType.Text);
	If iActIndex < 0 Then Exit;
	lbDevTypes.ItemIndex := iActIndex;
	sDevType := edDevType.Text;
	//Template stuff
	With sgTemplateTypes Do
		Begin
		 	IniSetValue(sIniFile, sDevType, 'Number', Int2Str(RowCount - 1));
  	  IniSetValue(sIniFile, sDevType, 'Comment', edDevTypeComment.Text);
			For i := 1 To RowCount - 1 Do
				IniSetValue(sIniFile, sDevType, 'Template' + Int2Str(i), Cells[1,i] + '#' + Cells[2,i]);
		End;
end;

procedure TfrmTemplates.TemplatesPopUpAddDTClick(Sender: TObject);
begin
	AddDT(Sender);
end;

procedure TfrmTemplates.TemplatesPopUpUpdateDTClick(Sender: TObject);
begin
	UpdateDT(Sender);
end;

procedure TfrmTemplates.TemplatesPopUpCopyDTClick(Sender: TObject);
begin
	CopyDT(Sender);
end;

procedure TfrmTemplates.TemplatesPopUpDeleteDTClick(Sender: TObject);
begin
	DeleteDT(Sender);
end;

procedure TfrmTemplates.bbAddDTClick(Sender: TObject);
begin
	AddDT(Sender);
end;

procedure TfrmTemplates.bbUpdateDTClick(Sender: TObject);
begin
	UpdateDT(Sender);
end;

procedure TfrmTemplates.bbDeleteDTClick(Sender: TObject);
begin
	DeleteDT(Sender);
end;

procedure TfrmTemplates.bbCopyDTClick(Sender: TObject);
begin
	CopyDT(Sender);
end;

//
//Stringgrid with Templates
//

procedure TfrmTemplates.sgTemplateTypesClick(Sender: TObject);
begin
	with sgTemplateTypes Do
  	Begin
			lblTemplateInfo.Caption := Int2Str(Col) + '/' + Int2Str(Row) + ' (' + Int2Str(RowCount - 1) + ')';
			//get the type and file from the 1. and 2. col
			sTemplateType := Cells[1,Row];
			sTemplateFile := Cells[2,Row];
			Caption :=  PGMNAME + sDevType + ':' + sTemplateType + ' - ' + sTemplateFile;
			SetStatusBar(Sender);
			if CheckFile(sTemplateDir + sTemplateFile) = True then
		  begin
			  mmTemplate.Lines.LoadFromFile(sTemplateDir + sTemplateFile);
				//search for keyword and replace them
				ReplaceDialog1Replace(Sender, '%Name', IniGetValue(sIniFile, 'Options', 'Name', 'Author'));
				ReplaceDialog1Replace(Sender, '%EMail', IniGetValue(sIniFile, 'Options', 'EMail', 'Author@AuthorWebsite.com'));
				ReplaceDialog1Replace(Sender, '%WebSite', IniGetValue(sIniFile, 'Options', 'WebSite', 'www.AuthorWebSite.Com'));
				//check on date and time
				If IniGetValue(sIniFile, 'Options', 'Date', '0') = '1' Then
					ReplaceDialog1Replace(Sender, '%Date', DateToStr(Date));
				If IniGetValue(sIniFile, 'Options', 'Time', '0') = '1' Then
					ReplaceDialog1Replace(Sender, '%Time', TimeToStr(Time));
				//lblMessage.Font.Color := clGrayText;
				//lblMessage.Caption := sTemplateFile;
		  end
	   else
			begin
		  	mmTemplate.Lines.Clear;
		  end;
		End;
end;

procedure TfrmTemplates.sgTemplateTypesKeyPress(Sender: TObject;
  var Key: Char);
begin
	With sgTemplateTypes Do
  	begin
		If sgTemplateTypes.Row = 0 Then
			sgTemplateTypes.EditorMode := False
	  Else
			sgTemplateTypes.EditorMode := True;
    End;
end;

procedure TfrmTemplates.AddTT(Sender: TObject);
begin
	with sgTemplateTypes do
  	begin
			If (RowCount >= 2) And (Cells[1,1] <> '') Then
      	Begin
					RowCount := RowCount + 1;
					Cells[0, RowCount - 1] := Int2Str(RowCount - 1);
					Cells[1, RowCount - 1] := '';
					Cells[2, RowCount - 1] := '';
				End;
      Row := RowCount - 1;
			Col := 1;
	    SetFocus;
      EditorMode := True;
		end;
end;

procedure TfrmTemplates.UpdateTT(Sender: TObject);
begin
	UpdateIniDevTypeSection(sDevType);
end;

procedure TfrmTemplates.DeleteTT(Sender: TObject);
Var
	iSelectedRow : Integer;
  i : Integer;
begin
	with sgTemplateTypes do
	begin
		iSelectedRow := Row;
		If (RowCount = 2) And (Row = 1) Then
		Begin
    	Cells[1, 1] := '';
      Cells[2, 1] := '';
    End;
		If RowCount > 2 Then
		Begin
			For i := iSelectedRow To RowCount - 1 Do
  	  Begin
				Cells[1, i] := Cells[1, i + 1];
				Cells[2, i] := Cells[2, i + 1];
			End;
			RowCount := RowCount - 1;
			Row := 1;
    End;
		Col := 1;
		SetFocus;
	End;
	sgTemplateTypesClick(Sender);
 	UpdateIniDevTypeSection(sDevType);
end;

procedure TfrmTemplates.TemplatesPopUpAddTTClick(Sender: TObject);
begin
	AddTT(Sender);
end;

procedure TfrmTemplates.TemplatesPopUpUpdateTTClick(Sender: TObject);
begin
	UpdateTT(Sender);
end;

procedure TfrmTemplates.TemplatesPopUpDeleteTTClick(Sender: TObject);
begin
	DeleteTT(Sender);
end;

procedure TfrmTemplates.bbAddTTClick(Sender: TObject);
begin
	AddTT(Sender);
end;

procedure TfrmTemplates.bbUpdateTTClick(Sender: TObject);
begin
	UpdateTT(Sender);
end;

procedure TfrmTemplates.bbDeleteTTClick(Sender: TObject);
begin
	DeleteTT(Sender);
end;

//
//About
//
procedure TfrmTemplates.imAboutClick(Sender: TObject);
begin
	frmAbout.Show;
end;

//
//Ini part if the form
//

Initialization
	//checks if already an instance of tplator exists
  hTPlatorHandle := CreateMutex(nil, TRUE, 'TPLATOR');
	//ok, is active, so show tplator
  if GetLastError = ERROR_ALREADY_EXISTS then
  	begin
			ShowWindow(hTPlatorHandle, SW_RESTORE);
			//an other possibility is give an errormesg and stop the app
			//AppMsg(sLngFile,mtError, MSGAPPRUNNING, '', '');
			//halt;
		end;

finalization
  if hTPlatorHandle <> 0 then
  	CloseHandle(hTPlatorHandle);

end.

